Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsink.F90	(revision 7525)
@@ -209,5 +209,6 @@
       !  Exchange between organic matter compartments due to coagulation/disaggregation
       !  ---------------------------------------------------
-!$OMP PARALLEL DO schedule(static) private(jk, jj, ji, zstep, zfact, zagg, zagg1, zagg2, zagg3, zagg4, zaggfe, zaggdoc, zaggdoc2, zaggdoc3)
+!$OMP PARALLEL DO schedule(static) private(jk, jj, ji, zstep, zfact, zagg, zagg1, zagg2) &
+!$OMP& private(zagg3, zagg4, zaggfe, zaggdoc, zaggdoc2, zaggdoc3)
       DO jk = 1, jpkm1
          DO jj = 1, jpj
@@ -259,5 +260,5 @@
      ! Total carbon export per year
      IF( iom_use( "tcexp" ) .OR. ( ln_check_mass .AND. kt == nitend .AND. knt == nrdttrc )  ) &
- &        t_oce_co2_exp = glob_sum( ( sinking(:,:,ik100) + sinking2(:,:,ik100) ) * e1e2t(:,:) * tmask(:,:,1) )
+        &        t_oce_co2_exp = glob_sum( ( sinking(:,:,ik100) + sinking2(:,:,ik100) ) * e1e2t(:,:) * tmask(:,:,1) )
      !
      IF( lk_iomput ) THEN
@@ -269,81 +270,81 @@
           IF( iom_use( "EPC100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) = ( sinking(ji,jj,ik100) + sinking2(ji,jj,ik100) ) * zfact * tmask(ji,jj,1) ! Export of carbon at 100m
-               END DO
-            END DO
-              CALL iom_put( "EPC100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) = ( sinking(ji,jj,ik100) + sinking2(ji,jj,ik100) ) * zfact * tmask(ji,jj,1) ! Export of carbon at 100m
+                END DO
+             END DO
+             CALL iom_put( "EPC100"  , zw2d )
           ENDIF
           IF( iom_use( "EPFE100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) = ( sinkfer(ji,jj,ik100) + sinkfer2(ji,jj,ik100) ) * zfact * tmask(ji,jj,1) ! Export of iron at 100m
-               END DO
-            END DO
-              CALL iom_put( "EPFE100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) = ( sinkfer(ji,jj,ik100) + sinkfer2(ji,jj,ik100) ) * zfact * tmask(ji,jj,1) ! Export of iron at 100m
+                END DO
+             END DO
+             CALL iom_put( "EPFE100"  , zw2d )
           ENDIF
           IF( iom_use( "EPCAL100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) = sinkcal(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of calcite at 100m
-               END DO
-            END DO
-              CALL iom_put( "EPCAL100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) = sinkcal(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of calcite at 100m
+                END DO
+             END DO
+             CALL iom_put( "EPCAL100"  , zw2d )
           ENDIF
           IF( iom_use( "EPSI100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) =  sinksil(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of bigenic silica at 100m
-               END DO
-            END DO
-              CALL iom_put( "EPSI100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) =  sinksil(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of bigenic silica at 100m
+                END DO
+             END DO
+             CALL iom_put( "EPSI100"  , zw2d )
           ENDIF
           IF( iom_use( "EXPC" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = ( sinking(ji,jj,jk) + sinking2(ji,jj,jk) ) * zfact * tmask(ji,jj,jk) ! Export of carbon in the water column
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPC"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = ( sinking(ji,jj,jk) + sinking2(ji,jj,jk) ) * zfact * tmask(ji,jj,jk) ! Export of carbon in the water column
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPC"  , zw3d )
           ENDIF
           IF( iom_use( "EXPFE" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = ( sinkfer(ji,jj,jk) + sinkfer2(ji,jj,jk) ) * zfact * tmask(ji,jj,jk) ! Export of iron 
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPFE"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = ( sinkfer(ji,jj,jk) + sinkfer2(ji,jj,jk) ) * zfact * tmask(ji,jj,jk) ! Export of iron 
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPFE"  , zw3d )
           ENDIF
           IF( iom_use( "EXPCAL" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = sinkcal(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of calcite 
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPCAL"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = sinkcal(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of calcite 
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPCAL"  , zw3d )
           ENDIF
           IF( iom_use( "EXPSI" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = sinksil(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of bigenic silica
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPSI"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = sinksil(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of bigenic silica
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPSI"  , zw3d )
           ENDIF
           IF( iom_use( "tcexp" ) )  CALL iom_put( "tcexp" , t_oce_co2_exp * zfact )   ! molC/s
@@ -526,5 +527,6 @@
       zval4 = 4. + xkr_eta
 
-!$OMP PARALLEL DO schedule(static) private(jk, jj, ji, znum, zeps, zfm, zsm, zdiv, zdiv1, zdiv2, zdiv3, zdiv4, zdiv5, zagg, zagg1, zagg2, zagg3, zagg4, zagg5, zfract, zaggdoc, zaggdoc1, zaggsh, zaggsi, znumdoc)
+!$OMP PARALLEL DO schedule(static) private(jk, jj, ji, znum, zeps, zfm, zsm, zdiv, zdiv1, zdiv2, zdiv3, zdiv4) &
+!$OMP& private(zdiv5, zagg, zagg1, zagg2, zagg3, zagg4, zagg5, zfract, zaggdoc, zaggdoc1, zaggsh, zaggsi, znumdoc)
       DO jk = 1,jpkm1
          DO jj = 1,jpj
@@ -632,114 +634,114 @@
           IF( iom_use( "EPC100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) = sinking(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of carbon at 100m
-               END DO
-            END DO
-              CALL iom_put( "EPC100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) = sinking(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of carbon at 100m
+                END DO
+             END DO
+             CALL iom_put( "EPC100"  , zw2d )
           ENDIF
           IF( iom_use( "EPN100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) = sinking2(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of number of aggregates ?
-               END DO
-            END DO
-              CALL iom_put( "EPN100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) = sinking2(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of number of aggregates ?
+                END DO
+             END DO
+             CALL iom_put( "EPN100"  , zw2d )
           ENDIF
           IF( iom_use( "EPCAL100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) = sinkcal(ji,jj,ik100) * zfact * tmask(ji,jj,1) !Export of calcite at 100m
-               END DO
-            END DO
-              CALL iom_put( "EPCAL100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) = sinkcal(ji,jj,ik100) * zfact * tmask(ji,jj,1) !Export of calcite at 100m
+                END DO
+             END DO
+             CALL iom_put( "EPCAL100"  , zw2d )
           ENDIF
           IF( iom_use( "EPSI100" ) )  THEN
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zw2d(ji,jj) =  sinksil(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of bigenic silica at 100m
-               END DO
-            END DO
-              CALL iom_put( "EPSI100"  , zw2d )
+             DO jj = 1, jpj
+                DO ji = 1, jpi
+                   zw2d(ji,jj) =  sinksil(ji,jj,ik100) * zfact * tmask(ji,jj,1) ! Export of bigenic silica at 100m
+                END DO
+             END DO
+             CALL iom_put( "EPSI100"  , zw2d )
           ENDIF
           IF( iom_use( "EXPC" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = sinking(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of carbon in the water column
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPC"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = sinking(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of carbon in the water column
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPC"  , zw3d )
           ENDIF
           IF( iom_use( "EXPN" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = sinking(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of carbon in the water column
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPN"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = sinking(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of carbon in the water column
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPN"  , zw3d )
           ENDIF
           IF( iom_use( "EXPCAL" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = sinkcal(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of calcite 
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPCAL"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = sinkcal(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of calcite 
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPCAL"  , zw3d )
           ENDIF
           IF( iom_use( "EXPSI" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = sinksil(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of bigenic silica
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "EXPSI"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = sinksil(ji,jj,jk) * zfact * tmask(ji,jj,jk) ! Export of bigenic silica
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "EXPSI"  , zw3d )
           ENDIF
           IF( iom_use( "XNUM" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = znum3d(ji,jj,jk) * tmask(ji,jj,jk) !  Number of particles on aggregats
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "XNUM"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = znum3d(ji,jj,jk) * tmask(ji,jj,jk) !  Number of particles on aggregats
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "XNUM"  , zw3d )
           ENDIF
           IF( iom_use( "WSC" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = wsbio3(ji,jj,jk) * tmask(ji,jj,jk) ! Sinking speed of carbon particles
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "WSC"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = wsbio3(ji,jj,jk) * tmask(ji,jj,jk) ! Sinking speed of carbon particles
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "WSC"  , zw3d )
           ENDIF
           IF( iom_use( "WSN" ) )  THEN
 !$OMP DO schedule(static) private(jk, jj, ji)
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zw3d(ji,jj,jk) = wsbio4(ji,jj,jk) * tmask(ji,jj,jk) ! Sinking speed of particles number
-                  END DO
-               END DO
-            END DO
-              CALL iom_put( "WSN"  , zw3d )
+             DO jk = 1, jpk
+                DO jj = 1, jpj
+                   DO ji = 1, jpi
+                      zw3d(ji,jj,jk) = wsbio4(ji,jj,jk) * tmask(ji,jj,jk) ! Sinking speed of particles number
+                   END DO
+                END DO
+             END DO
+             CALL iom_put( "WSN"  , zw3d )
           ENDIF
           !
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl.F90	(revision 7525)
@@ -61,6 +61,6 @@
       IF( l_trdtrc )  THEN
          CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrtrd ) ! temporary save of trends
+!$OMP PARALLEL DO schedule(static) private(jn,jk,jj,ji)
          DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpk
                DO jj = 1, jpj
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 7525)
@@ -76,6 +76,6 @@
       IF( l_trdtrc )  THEN
          CALL wrk_alloc( jpi,jpj,jpk,jptra,   ztrtrd )
+!$OMP PARALLEL DO schedule(static) private(jn,jk,jj,ji)
          DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpk
                DO jj = 1, jpj
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7525)
@@ -108,6 +108,6 @@
       IF( l_trdtrc )  THEN             ! trends: store now fields before the Asselin filter application
          CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrdt )
+!$OMP PARALLEL DO schedule(static) private(jn,jk,jj,ji)
          DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpk
                DO jj = 1, jpj
@@ -121,8 +121,12 @@
       !                                ! Leap-Frog + Asselin filter time stepping
       IF( neuler == 0 .AND. kt == nittrc000 ) THEN    ! Euler time-stepping at first time-step (only swap)
+!$OMP PARALLEL DO schedule(static) private(jn,jk,jj,ji)
          DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk)
             DO jk = 1, jpkm1
-               trn(:,:,jk,jn) = tra(:,:,jk,jn)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     trn(ji,jj,jk,jn) = tra(ji,jj,jk,jn)
+                  END DO
+               END DO
             END DO
          END DO
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 7525)
@@ -109,6 +109,6 @@
          ELSE                                         ! No restart or restart not found: Euler forward time stepping
            zfact = 1._wp
+!$OMP PARALLEL DO schedule(static) private(jn,jj,ji)
            DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jj,ji)
               DO jj = 1, jpj
                  DO ji = 1, jpi
@@ -121,6 +121,6 @@
          IF( ln_top_euler ) THEN
             zfact = 1._wp
+!$OMP PARALLEL DO schedule(static) private(jn,jj,ji)
            DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jj,ji)
               DO jj = 1, jpj
                  DO ji = 1, jpi
@@ -131,6 +131,6 @@
          ELSE
             zfact = 0.5_wp
+!$OMP PARALLEL DO schedule(static) private(jn,jj,ji)
            DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jj,ji)
               DO jj = 1, jpj
                  DO ji = 1, jpi
@@ -220,11 +220,11 @@
          IF( l_trdtrc ) THEN
 !$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
-           DO jk = 1, jpk
-              DO jj = 1, jpj
-                 DO ji = 1, jpi
-                    ztrtrd(ji,jj,jk) = tra(ji,jj,jk,jn) - ztrtrd(ji,jj,jk)
-                 END DO
-              END DO
-           END DO                                      ! online coupling free surface or offline with free surface
+            DO jk = 1, jpk
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     ztrtrd(ji,jj,jk) = tra(ji,jj,jk,jn) - ztrtrd(ji,jj,jk)
+                  END DO
+               END DO
+            END DO                                      ! online coupling free surface or offline with free surface
             CALL trd_tra( kt, 'TRC', jn, jptra_nsr, ztrtrd )
          END IF
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 7525)
@@ -71,6 +71,6 @@
       IF( l_trdtrc )  THEN
          CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrtrd )
+!$OMP PARALLEL DO schedule(static) private(jn,jk,jj,ji)
          DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpk
                DO jj = 1, jpj
@@ -90,7 +90,11 @@
       IF( l_trdtrc )   THEN                      ! save the vertical diffusive trends for further diagnostics
          DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpkm1
-               ztrtrd(:,:,jk,jn) = ( ( tra(:,:,jk,jn) - trb(:,:,jk,jn) ) / r2dttrc ) - ztrtrd(:,:,jk,jn)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     ztrtrd(ji,jj,jk,jn) = ( ( tra(ji,jj,jk,jn) - trb(ji,jj,jk,jn) ) / r2dttrc ) - ztrtrd(ji,jj,jk,jn)
+                  END DO
+               END DO
             END DO
             CALL trd_tra( kt, 'TRC', jn, jptra_zdf, ztrtrd(:,:,:,jn) )
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7525)
@@ -119,15 +119,19 @@
 !$OMP PARALLEL DO schedule(static) private(jk)
       DO jk = 1, jpk
-         cvol(:,:,jk) = e1e2t(:,:) * e3t_n(:,:,jk) * tmask(:,:,jk)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               cvol(ji,jj,jk) = e1e2t(ji,jj) * e3t_n(ji,jj,jk) * tmask(ji,jj,jk)
+            END DO
+         END DO
       END DO
       IF( lk_degrad ) THEN  
 !$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
-      DO jk = 1, jpk
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               cvol(ji,jj,jk) = cvol(ji,jj,jk) * facvol(ji,jj,jk)    ! degrad option: reduction by facvol
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  cvol(ji,jj,jk) = cvol(ji,jj,jk) * facvol(ji,jj,jk)    ! degrad option: reduction by facvol
+               END DO
             END DO
          END DO
-      END DO
       END IF
       !                                                              ! total volume of the ocean 
@@ -255,6 +259,6 @@
         ENDIF
         !
+!$OMP PARALLEL DO schedule(static) private(jn,jk,jj,ji)
       DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
          DO jk = 1, jpk
             DO jj = 1, jpj
@@ -268,6 +272,6 @@
       ENDIF
  
+!$OMP PARALLEL DO schedule(static) private(jn,jk,jj,ji)
       DO jn = 1, jptra
-!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
          DO jk = 1, jpk
             DO jj = 1, jpj
